<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>音频Audio</title>
</head>
<body>
    <div class="web-api-cnt">
        <div class="web-api-card">
            <div class="web-api-card-head"> Demo - Audio </div>
            <div class="web-api-card-body">
                <div id="error" class="close"></div>
                <div>
                    <audio controls src="http://10.8.192.82:38000/static/Radio/phq_pz6r0_SIP-60000062_08590769_20201009153230.wav" id="audio"></audio>
                </div>
                <div>
                    <button onclick="audioFromAudioFile.init()">Init</button>
                    <button onclick="audioFromAudioFile.play()">Play</button>
                    <button onclick="audioFromAudioFile.pause()">Pause</button>
                    <button onclick="audioFromAudioFile.stop()">Stop</button>
                </div>
                <div>
                    <span>Vol: 
                        <input 
                            onchange="audioFromAudioFile.changeVolume()" 
                            type="range" 
                            id="vol" 
                            min="1" 
                            max="3"
                            step="0.01" 
                            value="1" />
                    </span>
                    <span>Pan: 
                        <input 
                            onchange="audioFromAudioFile.changePan()" 
                            type="range" id="panner" 
                            min="-1"
                            max="1" 
                            step="0.01" 
                            value="0" />
                    </span>
                </div>
            </div>
        </div>
    </div>
    <script>
        let audioFromAudioFile = (function () {
            var audioContext
            var volNode
            var pannerNode
            var mediaSource
            function init() {
                console.log("Init")
                try {
                    let AudioContext=window.AudioContext || window.webkitAudioContext;
                    audioContext = new AudioContext()
                    mediaSource = audioContext.createMediaElementSource(audio)
                    volNode = audioContext.createGain()
                    volNode.gain.value = 1
                    pannerNode = new StereoPannerNode(audioContext, { pan: 0 });
                    mediaSource.connect(volNode).connect(pannerNode).connect(audioContext.destination)
                    console.log(volNode)
                }
                catch (e) {
                    error.innerHTML = "The Web Audio API is not supported in this device."
                    error.classList.remove("close")
                }
            }

            function play() {
                audio.play()
            }

            function pause() {
                audio.pause()
            }

            function stop() {
                audio.stop()
            }

            function changeVolume() {
                volNode.gain.value = document.getElementById('vol').value
            }

            function changePan() {
                pannerNode.gain.value = tdocument.getElementById('panner').value
            }

            return {
                init,
                play,
                pause,
                stop,
                changePan,
                changeVolume
            }
        })()
    </script>
</body>
</html>